# elimdups.py
# Removes duplicate lines in a file.
# Author: Neil C. Rowe, 2/12
import sys

# Allows same program to handle Windows and Linux line reads
def endclean(OS):
    S = OS
    M = len(S)
    while ((M > 0) and \
           (S[M-1] in ['\n','\r','\t','\f','\a','\b','\v',' ']) ):             
        S = S[0:M-1]
        M = M-1
    return S

def elimdups(infilename):
    k = max(infilename.rfind('/'),infilename.rfind('\\'))
    outfilename = infilename[0:k+1] + 'undup_' + \
                  infilename[k+1:len(infilename)]
    out = open(outfilename, 'w', encoding='utf-8')
    data = {}
    linenum = 0
    fid = open(infilename, 'r', encoding='utf-8')
    try:
        line = fid.readline()
    except:
        print('First line is faulty')
        line = '$$$$$$FAULTY_LINE'
    while line:
        line = endclean(line)
        if not (data.get(line,False)):
            data[line] = True
            out.write(line + '\n')
        try:
            line = fid.readline()
        except:
            print('Line',linenum,'is faulty')
            line = '$$$$$$FAULTY_LINE'
        linenum = linenum + 1
    fid.close()
    out.close()

if __name__=="__main__":
    infilename = sys.argv[1]
    elimdups(infilename)
