# mergelines.py
# Appends the lines of one file to those of the other.
import sys

# Allows same program to handle Windows and Linux line reads
def endclean(OS):
    S = OS
    M = len(S)
    while ((M > 0) and \
           (S[M-1] in ['\n','\r','\t','\f','\a','\b','\v',' ']) ):             
        S = S[0:M-1]
        M = M-1
    return S   

def mergelines(infile1,infile2,delimchar):
    ks = infile1.rfind('/')
    if (ks > -1):
        outfile = infile1[0:ks+1] + 'mergelines.out'
    else:
        outfile = 'mergelines.out'
    fid1 = open(infile1, 'r', encoding='utf-8')
    fid2 = open(infile2, 'r', encoding='utf-8')
    out = open(outfile, 'w', encoding='utf-8')
    line1 = fid1.readline()
    line2 = fid2.readline()
    while line1 and line2:
        out.write(endclean(line1) + delimchar + endclean(line2) + '\n')
        line1 = fid1.readline()
        line2 = fid2.readline()
    if line1:
        print('Merged file',infile1,'has too many lines compared to',infile2)
    if line2:
        print('Merged file',infile2,'has too many lines compared to',infile1)
    fid1.close()
    fid2.close()
    out.close()

if __name__=="__main__":
    infile1 = sys.argv[1]
    infile2 = sys.argv[2]
    delimchar = sys.argv[3]
    mergelines(infile1,infile2,delimchar)
    
