# partition_members.py
# Given two text files, returns the lines in the first file that
# do not occur in the second file (uniquelines.txt) and lines
# that do (commonlines.txt).
# The second file is hashed (but not the first) so it should be
# kept short if at all possible.
# Author: Neil C. Rowe, 10/12
import sys

# Allows same program to handle Windows and Linux line reads
def endclean(OS):
    S = OS
    M = len(S)
    while ((M > 0) and \
           (S[M-1] in ['\n','\r','\t','\f','\a','\b','\v',' ']) ):
        S = S[0:M-1]
        M = M-1
    return S

def partition_members(file1,file2):
    fid = open(file2, 'r', encoding='utf-8')
    linecache = {}
    line = fid.readline()
    while line:
        line = endclean(line)
        linecache[line] = 1
        line = fid.readline()
    fid.close()
    ks = file1.rfind('/')
    if (ks > -1):
        dirname = file1[0:ks+1]
    else:
        dirname = ''
    out1 = open(dirname + 'uniquelines.out', 'w', encoding='utf-8')
    out2 = open(dirname + 'commonlines.out', 'w', encoding='utf-8')
    fid = open(file1, 'r', encoding='utf-8')
    line = fid.readline()
    while line:
        line = endclean(line)
        if (linecache.get(line,0) == 0):
            out1.write(line + '\n')
        else:
            out2.write(line + '\n')
        line = fid.readline()
    fid.close()
    out1.close()
    out2.close()

if __name__=="__main__":
    file1 = sys.argv[1]
    file2 = sys.argv[2]
    partition_members(file1,file2)
    
