# quickstats.py
# Calculates mean, standard deviation, maximum, and minimum
# for each column of data in a text file delimited by spaces.
# Author: Neil Rowe, ncrowe@nps.edu, 1/21
import sys, math, quickstats_col
# Allows same program to handle Windows and Linux line reads
def endclean(OS):
    S = OS
    M = len(S)
    while ((M > 0) and \
           (S[M-1] in ['\n','\r','\t','\f','\a','\b','\v',' ']) ):                        
        S = S[0:M-1]
        M = M-1
    return S  

def quickstats(file,delimiter):
    ks = file.rfind('/')
    dirname = file[0:ks+1]
    out = open(dirname + 'quickstats.out', 'w')
    fid = open(file,'r',encoding='utf-8')
    line = fid.readline()
    M = len((endclean(line)).split(delimiter))
    for j in list(range(M)):
        quickstats_col.quickstats_col(file,j,delimiter,out)
    out.close()
    
if __name__=="__main__":
   file = sys.argv[1]
   delimiter = sys.argv[2]
   quickstats(file,delimiter)
