# randchoose.py
# Selects lines of a file randomly with a given probability
import sys, random

# Allows same program to handle Windows and Linux line reads
def endclean(OS):
    S = OS
    M = len(S)
    while ((M > 0) and \
           (S[M-1] in ['\n','\r','\t','\f','\a','\b','\v',' ']) ):             
        S = S[0:M-1]
        M = M-1
    return S

def randchoose(infilename,chooseprob):
    k = infilename.rfind('/')
    M = len(infilename)
    if (k >= -1):
        outfilename = infilename[0:k+1] + 'randselect_' + infilename[k+1:M]
    else:
        outfilename = 'randselect_' + infilename
    outfile = open(outfilename, 'w', encoding='utf-8')
    totalcount = 0
    linecount = 0
    with open(infilename, 'r', encoding='utf-8') as f:
        for line in f:
            totalcount = totalcount + 1
            if (random.random() <= chooseprob):
                outfile.write(line)
                linecount = linecount + 1
    outfile.close()
    print(linecount,'lines selected out of',totalcount)

if __name__=="__main__":
    infilename = sys.argv[1]
    chooseprob = float(sys.argv[2])
    randchoose(infilename,chooseprob)
