# sortrows.py
# Sorts lines of a text file.
# Author: Neil C. Rowe, 4/14
import sys

# Allows same program to handle Windows and Linux line reads
def endclean(OS):
    S = OS
    M = len(S)
    while ((M > 0) and \
           (S[M-1] in ['\n','\r','\t','\f','\a','\b','\v',' ']) ):                        
        S = S[0:M-1]
        M = M-1
    return S

def sortrows(filename):
    rows = []
    with open(filename, 'r', encoding='utf-8') as f:
        for line in f:
            rows.append(endclean(line))
    rows.sort()
    k = filename.rfind('.')
    outfilename = filename[0:k] + '_sort' + filename[k:len(filename)]
    out = open(outfilename, 'w', encoding='utf-8')
    for i in list(range(len(rows))):
        out.write(rows[i] + '\n')
    out.close()

if __name__=="__main__":
    filename = sys.argv[1]
    sortrows(filename)
