# take_subset.py
# Transfers to output all lines of input file (arg 1) that have
# a particular string (arg 3) for a particular column (arg 2).
# where input is delimited by a given character (arg 4).
# Output file name encodes the second and third args.
import sys

# Allows same program to handle Windows and Linux line reads
def endclean(OS):
    S = OS
    M = len(S)
    while ((M > 0) and \
           (S[M-1] in ['\n','\r','\t','\f','\a','\b','\v',' ']) ):          
        S = S[0:M-1]
        M = M-1
    return S

def take_subset(filename,colnum,targetstring,delimchar):
    fid = open(filename, 'r', encoding='utf=8')
    tag = 'col' + str(colnum) + '=' + targetstring + '_'
    ks = filename.rfind('/')
    if (ks > -1):
        outfilename = filename[0:ks+1] + tag + filename[ks+1:len(filename)]
    else:
        outfilename = tag + filename
    out = open(outfilename, 'w', encoding='utf-8')
    line = fid.readline()
    count = 0
    totalcount = 0
    while line:
        line = endclean(line)
        pline = line.split(delimchar)
        if (len(pline) > colnum):
            # print(pline[colnum],targetstring)
            if (pline[colnum] == targetstring):
                out.write(line + '\n')
                count = count + 1
        line = fid.readline()
        totalcount = totalcount + 1
    fid.close()
    out.close()
    print('Matched',count,'of total count',totalcount)

if __name__=="__main__":
    filename = sys.argv[1]
    colnum = int(sys.argv[2])
    targetstring = sys.argv[3]
    delimchar = sys.argv[4]
    take_subset(filename,colnum,targetstring,delimchar)
